---
title: llarp::layers::platform::AddrMapper
summary: in charge of mapping flow addresses and platform addresses to each other 

---

# llarp::layers::platform::AddrMapper



in charge of mapping flow addresses and platform addresses to each other 


`#include <addr_mapper.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| void | **[put](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-put)**([flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) flow, [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) addr)<br>unconditionally put an entry in  |
| std::optional< [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) > | **[get_addr_for_flow](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-get-addr-for-flow)**(const [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) & flow) const<br>get a platform for a flow if it exists  |
| std::optional< [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) > | **[get_flow_for_addr](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-get-flow-for-addr)**(const [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) & addr) const<br>given a platform address, get the flow for it if it exists.  |

## Public Functions Documentation

### function put

```cpp
void put(
    flow::FlowInfo flow,
    PlatformAddr addr
)
```

unconditionally put an entry in 

### function get_addr_for_flow

```cpp
std::optional< PlatformAddr > get_addr_for_flow(
    const flow::FlowInfo & flow
) const
```

get a platform for a flow if it exists 

### function get_flow_for_addr

```cpp
std::optional< flow::FlowInfo > get_flow_for_addr(
    const PlatformAddr & addr
) const
```

given a platform address, get the flow for it if it exists. 

-------------------------------

Updated on 2023-01-23 at 21:15:39 +0000