---
title: llarp::layers::platform::FlowTraffic_IO

---

# llarp::layers::platform::FlowTraffic_IO





## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual void | **[write_many_to_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-write-many-to-flow-layer)**(EtherType_t kind, [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) to, std::vector< std::vector< byte_t >> datums)<br>send many dataums of the same kind to a flow on the flow layer.  |
| void | **[write_to_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-write-to-flow-layer)**(EtherType_t kind, [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) to, std::vector< byte_t > data)<br>helper to write one datum to the flow layer  |
| virtual std::vector< [flow::Traffic](Classes/structllarp_1_1layers_1_1flow_1_1Traffic.md) > | **[read_from_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-read-from-flow-layer)**()<br>does a full read and drains everything from flow layer and returns what was read if anything was.  |
| virtual void | **[wakeup](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#function-wakeup)**() const<br>wake up the flow layer telling it we sent it something, idempotently.  |

## Protected Attributes

|                | Name           |
| -------------- | -------------- |
| [flow::FlowLayer_Base](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer__Base.md) & | **[m_flow_layer](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md#variable-m-flow-layer)**  |

## Public Functions Documentation

### function write_many_to_flow_layer

```cpp
virtual void write_many_to_flow_layer(
    EtherType_t kind,
    flow::FlowInfo to,
    std::vector< std::vector< byte_t >> datums
)
```

send many dataums of the same kind to a flow on the flow layer. 

this call MUST wake up the flow layer idempotently. 


### function write_to_flow_layer

```cpp
inline void write_to_flow_layer(
    EtherType_t kind,
    flow::FlowInfo to,
    std::vector< byte_t > data
)
```

helper to write one datum to the flow layer 

### function read_from_flow_layer

```cpp
virtual std::vector< flow::Traffic > read_from_flow_layer()
```

does a full read and drains everything from flow layer and returns what was read if anything was. 

### function wakeup

```cpp
virtual void wakeup() const
```

wake up the flow layer telling it we sent it something, idempotently. 

## Protected Attributes Documentation

### variable m_flow_layer

```cpp
flow::FlowLayer_Base & m_flow_layer;
```


-------------------------------

Updated on 2023-01-23 at 21:15:39 +0000