---
title: llarp::layers::platform::OSTraffic_IO

---

# llarp::layers::platform::OSTraffic_IO





## Public Functions

|                | Name           |
| -------------- | -------------- |
| virtual std::vector< [OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md) > | **[read_platform_traffic](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO.md#function-read-platform-traffic)**() const<br>read from the os.  |
| virtual void | **[write_platform_traffic](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO.md#function-write-platform-traffic)**(std::vector< [OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md) > && traff) const<br>write to the os.  |
| virtual void | **[wakeup](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO.md#function-wakeup)**() const<br>wake up lokinet event loop telling it we sent some things to the network.  |

## Public Functions Documentation

### function read_platform_traffic

```cpp
virtual std::vector< OSTraffic > read_platform_traffic() const
```

read from the os. 

this MUST NOT have any internal userland buffering from previous calls to [read_platform_traffic()](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO.md#function-read-platform-traffic). 


### function write_platform_traffic

```cpp
virtual void write_platform_traffic(
    std::vector< OSTraffic > && traff
) const
```

write to the os. 

this call MUST do an idempotent wakeup of the os layer. 


### function wakeup

```cpp
virtual void wakeup() const
```

wake up lokinet event loop telling it we sent some things to the network. 

-------------------------------

Updated on 2023-01-23 at 21:15:39 +0000