---
title: llarp/layers/platform/addr_mapper.hpp

---

# llarp/layers/platform/addr_mapper.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::platform](Namespaces/namespacellarp_1_1layers_1_1platform.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::platform::AddrMapper](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md)** <br>in charge of mapping flow addresses and platform addresses to each other  |




## Source code

```cpp
#pragma once

#include "platform_addr.hpp"

#include <llarp/layers/flow/flow_info.hpp>

#include <functional>
#include <string>
#include <optional>
#include <type_traits>
#include <unordered_set>

namespace llarp::layers::platform
{

  class AddrMapper
  {
    std::unordered_set<std::pair<flow::FlowInfo, PlatformAddr>> m_addrs;

   public:
    void
    put(flow::FlowInfo flow, PlatformAddr addr);

    std::optional<PlatformAddr>
    get_addr_for_flow(const flow::FlowInfo& flow) const;

    std::optional<flow::FlowInfo>
    get_flow_for_addr(const PlatformAddr& addr) const;
  };

}  // namespace llarp::layers::platform
```


-------------------------------

Updated on 2023-01-23 at 21:15:39 +0000
