---
title: llarp/layers/platform/platform_addr.hpp

---

# llarp/layers/platform/platform_addr.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::platform](Namespaces/namespacellarp_1_1layers_1_1platform.md)**  |
| **[std](Namespaces/namespacestd.md)** <br>STL namespace.  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::layers::platform::PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md)** <br>a (ipv6 address, flowlabel) tuple that we use for platform layer side addressing  |
| struct | **[std::hash< llarp::layers::platform::PlatformAddr >](Classes/structstd_1_1hash_3_01llarp_1_1layers_1_1platform_1_1PlatformAddr_01_4.md)**  |




## Source code

```cpp
#pragma once

#include <cstdint>
#include <llarp/net/net_int.hpp>

#include <string>
#include <optional>
#include <functional>

namespace llarp::layers::platform
{

  struct PlatformAddr
  {
    net::ipv6addr_t ip;

    net::flowlabel_t flowlabel{};

    PlatformAddr(net::ipaddr_t ip_, std::optional<net::flowlabel_t> flow_ = std::nullopt);

    std::string
    ToString() const;
  };

}  // namespace llarp::layers::platform

namespace std
{
  template <>
  struct hash<llarp::layers::platform::PlatformAddr>
  {
    size_t
    operator()(const llarp::layers::platform::PlatformAddr& addr) const
    {
      return std::hash<llarp::uint128_t>{}(addr.ip.n)
          ^ (std::hash<uint32_t>{}(addr.flowlabel.n) << 3);
    }
  };
}  // namespace std
```


-------------------------------

Updated on 2023-01-23 at 21:15:39 +0000
