---
title: llarp::layers::platform

---

# llarp::layers::platform



## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::platform::AddrMapper](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md)** <br>in charge of mapping flow addresses and platform addresses to each other  |
| class | **[llarp::layers::platform::PlatformLayer_Base](Classes/classllarp_1_1layers_1_1platform_1_1PlatformLayer__Base.md)** <br>owner of all platform layer components  |
| class | **[llarp::layers::platform::OSTraffic_IO](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO.md)**  |
| class | **[llarp::layers::platform::FlowTraffic_IO](Classes/classllarp_1_1layers_1_1platform_1_1FlowTraffic__IO.md)**  |
| class | **[llarp::layers::platform::PlatformDriver_Base](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver__Base.md)** <br>base type that is responsible for bridging the os and the flow layer.  |
| class | **[llarp::layers::platform::NameResolverJob_Base](Classes/classllarp_1_1layers_1_1platform_1_1NameResolverJob__Base.md)** <br>a one shot job that will resolve a string to a resolved name to a platform address.  |
| struct | **[llarp::layers::platform::PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md)** <br>a (ipv6 address, flowlabel) tuple that we use for platform layer side addressing  |
| struct | **[llarp::layers::platform::OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md)** <br>platfrom datum that is used to read and write to the os  |

## Types

|                | Name           |
| -------------- | -------------- |
| enum class| **[PlatformKind](Namespaces/namespacellarp_1_1layers_1_1platform.md#enum-platformkind)** { ip, embedded, embedded, ip} |
| enum class| **[EtherType_t](Namespaces/namespacellarp_1_1layers_1_1platform.md#enum-ethertype-t)** { ipv4_unicast, ip_hybrid_unicast, plainquic, proto_auth}<br>the kind of traffic we are tunneling  |
| enum class uint8_t | **[PlatformKind](Namespaces/namespacellarp_1_1layers_1_1platform.md#enum-platformkind)** { ip, embedded, embedded, ip} |
| using std::variant< std::string_view, [dns::Question](Classes/structllarp_1_1dns_1_1Question.md) > | **[UnresolvedName_t](Namespaces/namespacellarp_1_1layers_1_1platform.md#using-unresolvedname-t)** <br>a variant for a name we have yet to resolve  |

## Types Documentation

### enum PlatformKind

| Enumerator | Value | Description |
| ---------- | ----- | ----------- |
| ip | | IP via tun interface.   |
| embedded | | IP via tap interface giving layer 2 hints.  embedded lokinet  |
| embedded | | embedded lokinet  embedded lokinet  |
| ip | | IP via tun interface.   |




### enum EtherType_t

| Enumerator | Value | Description |
| ---------- | ----- | ----------- |
| ipv4_unicast | | ipv4 unicast traffic   |
| ip_hybrid_unicast | | ipv4/ipv6 unicast traffic   |
| plainquic | | plainquic stream   |
| proto_auth | | flow layer auth protocol   |



the kind of traffic we are tunneling 

### enum PlatformKind

| Enumerator | Value | Description |
| ---------- | ----- | ----------- |
| ip | | IP via tun interface.   |
| embedded | | IP via tap interface giving layer 2 hints.  embedded lokinet  |
| embedded | | embedded lokinet  embedded lokinet  |
| ip | | IP via tun interface.   |




### using UnresolvedName_t

```cpp
using llarp::layers::platform::UnresolvedName_t = typedef std::variant<std::string_view, dns::Question>;
```

a variant for a name we have yet to resolve 






-------------------------------

Updated on 2023-01-23 at 21:15:39 +0000